*! version 1.0.0 March 28, 2006 @ 15:13:16
*! Generates Variable holding the (person specific) number of episodes (of type seqitem)
program define _gsqepicount
version 9

	gettoken type 0 : 0
	gettoken h    0 : 0 
	gettoken eqs  0 : 0

	syntax varname [if] [in] [, i(varname) t(varname) sq(varname) type(string) ] 
	
	marksample touse, novarlist


	// Sq-Data
	capture _sqset `varlist' `i' `t'
	if _rc {
		di as error "data not declared as SQ-data; use -sqset-"
		exit 9
	}
	
	// Options
	local charsuffix = cond("`type'"!="","`=subinstr("`type'","-","M",.)'","")
	local counter = cond("`type'"=="","1","`_dta[SQis]'==`type'")
	
	if "`type'" != ""  {
		local item `"& `_dta[SQis]' == `type' "'
	}
	
	quietly {
		tempvar valid
		gen byte `valid' = cond("`missing'"=="",`_dta[SQis]' < .,1)
		
		// Generate Variable
		by `valid' `touse' `_dta[SQiis]' (`_dta[SQtis]'), sort: ///
		  gen `h' = `_dta[SQis]' ~= `_dta[SQis]'[_n-1]     ///
		  if `touse' & `valid' `item'
		by `touse' `_dta[SQiis]', sort: replace `h' = sum(`h') if `touse'
		by `touse' `_dta[SQiis]': replace `h' = `h'[_N] if `touse'
			
		if "`type'" == "" {
			label variable `h' "Overall number of episodes"
		}
		if "`type'" != "" {
			label variable `h' "Number of episodes of type `type'"
		}

		char _dta[SQepicount`charsuffix'] "$EGEN_Varname"
	}
	
end

	
