*! version 1.0.0 March 16, 2006 @ 13:10:16
*! Generates Variable holding the (person specific) length of the observed sequences (of type)
program _gsqlength
version 9

	gettoken type 0 : 0
	gettoken h    0 : 0
	gettoken eqs  0 : 0

	syntax [varname(default=none)] [if] [in] ///
	  [, i(varname) t(varname) sq(varname) type(string) ]

	marksample touse, novarlist
		
	// Sq-Data
	capture _sqset `varlist' `i' `t'
	if _rc {
		di as error "data not declared as SQ-data; use -sqset-"
		exit 9
	}
	
	// Options
	// -------
		
	local charsuffix = cond("`type'"!="","`=subinstr("`type'","-","M",.)'","")
	local counter = cond("`type'"=="","1","`_dta[SQis]'==`type'")
	
	// Generate Variable
	// -----------------
	
	by `touse' `_dta[SQiis]' (`_dta[SQtis]'), sort: gen `h' = sum(`counter') if `touse'
	quietly by `touse' `_dta[SQiis]' (`_dta[SQtis]'), sort: replace `h' = `h'[_N] if `touse'
	
	if "`type'" == "" {
		label variable `h' "Overall length of observed sequence"
	}
	if "`type'" != "" {
		label variable `h' "Overall length of observed sequence of type `type'"
	}
	
	char _dta[SQlength`charsuffix'] "$EGEN_Varname"
	
end
	

