	// standardisation (divide distance by the longer sequence)
	Standard

	// reshape into wide format => distance matrix for cluster analysis
	reshape wide dist, i(`_dta[SQiis]') j(`_dta[SQtis]')

	// adding missing first observation (seq_a = 1)
	set obs `=_N+1'
	replace `_dta[SQiis]' = 1 if `_dta[SQiis]' == .
	sort `_dta[SQiis]'

	// adding missing last variable
	generate dist`=_N' = .

	// recoding missings to 0
	* should this be an option?
	foreach var of varlist `_dta[SQis]'* {
		replace `var' = 0 if mi(`var')
	}

	tempfile dismat
	save `dismat'

	// converting distance-variables into distance-matrix & transpose

	local max = _N
	mkmat dist1-dist`max', matrix(dist)
	matrix tdist = dist'
	matrix cdist = dist + tdist

	// clustering of standardised distances (wardslinkage)
	
	









	cluster generate wardgroup = groups(3/10), name(wards)
	*~~~~~ dendrogram cut by 10 groups
	cluster dendrogram wards, cutnumber(10) horizontal showcount ///
		ylabel(, angle(45) labsize(vsmall)) title("sample: waves `wbeg' to `wend'", size(medium)) ///
		xtitle("dissmilarity measure", size(small)) xlabel(, labsize(small))
	graph save "c:/projects/dissertation/output/dend10_`wbeg'to`wend'.gph", replace
	*~~~~~ dendrogram cut by 6 groups
	cluster dendrogram wards, cutnumber(6) horizontal showcount ///
		ylabel(, angle(45) labsize(vsmall)) title("sample: waves `wbeg' to `wend'", size(medium)) ///
		xtitle("dissmilarity measure", size(small)) xlabel(, labsize(small))
	graph save "c:/projects/dissertation/output/dend6_`wbeg'to`wend'.gph", replace
	*~~~~~ dendrogram cut by 5 groups
	cluster dendrogram wards, cutnumber(5) horizontal showcount ///
		ylabel(, angle(45) labsize(vsmall)) title("sample: waves `wbeg' to `wend'", size(medium)) ///
		xtitle("dissmilarity measure", size(small)) xlabel(, labsize(small))
	graph save "c:/projects/dissertation/output/dend5_`wbeg'to`wend'.gph", replace
	*~~~~~ dendrogram cut by 4 groups
	cluster dendrogram wards, cutnumber(4) horizontal showcount ///
		ylabel(, angle(45) labsize(vsmall)) title("sample: waves `wbeg' to `wend'", size(medium)) ///
		xtitle("dissmilarity measure", size(small)) xlabel(, labsize(small))
	graph save "c:/projects/dissertation/output/dend4_`wbeg'to`wend'.gph", replace

*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	*~~~~~ merge relation- to cluster-file
	*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	drop `_dta[SQis]'
	generate `_dta[SQis]' = wards_id
	sort `_dta[SQis]'
	merge `_dta[SQis]' using "$disspath/rel`wbeg'to`wend'.dta"
	*~~~~~ security check
	assert _merge == 3
	drop _merge
	order newpid1
	rename newpid1 newpid
	sort newpid

*~~~~~~~~~~~~~~~~~~~~~~
	*~~~~~ merge panel-file
	*~~~~~~~~~~~~~~~~~~~~~~
	merge newpid using "$disspath/3pan`wbeg'to`wend'.dta"
	*~~~~~ security check
	assert _merge == 3
	drop _merge
	sort newpid
	*~~~~~~~~~~~~~~~~~~~~~
	*~~~~~ merge prop-file
	*~~~~~~~~~~~~~~~~~~~~~
	merge newpid using "$disspath/prop`wbeg'to`wend'.dta"
	recode _all (missing = .)
	*~~~~~ security checks
	assert _merge == 3
	drop _merge
	assert newpid == `_dta[SQis]'
	assert newpid == wards_id
	assert sex == sex1
	assert country == country1
	assert edulev == edulev1
	drop id_tda sex1 edulev1 country1
	drop pid `_dta[SQis]'

*~~~~~ calculate stopping measures
	clustermat stop, rule(calinski) group(3/10) variables(status1-status60)
	save "$disspath/tmp_cl`wbeg'to`wend'.dta", replace








	



program define Standard
	generate long_seq = len_b if len_b > len_a | len_b == len_a
	replace long_seq = len_a if len_a > len_b
	generate dist2 = dist/long_seq
	drop long_seq dist len_a len_b newpid1 newpid2 country1 country2 sex1 sex2 edulev1 edulev2
	rename dist2 dist
end
