*! version 1.0.0 January 3, 2006 @ 16:06:36
*! List information on (person specific) sequences
program sqstattab2
version 9
	syntax varlist(min=1 max=2) [if] [in] [, sq(varname) i(varname) t(varname) keep clear noauto * ]

	// Sq-Data
	capture _sqset `sq' `i' `t'
	if _rc {
		di as error "data not declared as SQ-data; use -sqset-"
		exit 9
	}

	// Catch varnames of if
	if "`if'" != "" {
		tokenize "`if'", parse(" =+-*/^~!|&<>(),.")
		while "`1'" != "" {
			capture confirm variable `1'
			if !_rc {
				local iflist  "`iflist' `1'"
			}
			macro shift
		}
		if "`iflist'" != "" CheckConstant `iflist', stop
	}

	// Options
	if "`keep'" == "" {
		preserve
	}
	else {
		if r(changed) {
			if "`clear'" == "" {
				di as error "no; data in memory would be lost"
				exit 4
			}
		}
	}

	// Check if hand made varlist are constants above time
	if "`varlist'" != "" CheckConstant `varlist'
	local varlist `r(checked)' 

	// Use egen-erated sequence-information
	if "`auto'" != "noauto" {
		local SQgapcount: char _dta[SQgapcount]
		local SQgaplength: char _dta[SQgaplength]
		local SQitemcount: char _dta[SQitemcount]
		local SQepicount: char _dta[SQepicount]
		local SQlength: char _dta[SQlength]
		quietly levelsof `_dta[SQis]', local(K) 
		foreach k of local K {
			local charsuffix = cond(`k'<0,"`=subinstr("`k'","-","M",.)'","`k'")
			local SQlengthvars "`SQlengthvars' `: char _dta[SQlength`charsuffix']'"
		}
		local autolist "`SQlength' `SQlengthvars' `SQgapcount' `SQgaplength' `SQitemcount' `SQepicount'"
		format `autolist' %4.0f
	}
		
	// Output
	// ------
	
	keep `_dta[SQiis]' `_dta[SQis]' `varlist' `autolist' `iflist'
	quietly by `_dta[SQiis]': keep if _n==1
	if `:word count `varlist'' == 1 {
		foreach var of local autolist {
			tabulate `var' `varlist' `if' `in', `options'
		}
	}
	else {
		tabulate `varlist' `if' `in', `options'
	}
		
end
		
	
program CheckConstant, rclass
	syntax varlist(default=none) [, stop]
	sort `_dta[SQiis]'
	foreach var of local varlist {
		capture by `_dta[SQiis]': assert `var' == `var'[_n-1] if _n != 1
		if _rc & "`stop'" == "" {
			di as res "`var'" as text " is not constant over time; not used"
			local varlist: subinstr local varlist "`var'" "", word
		}
		if _rc & "`stop'" != "" {
			di as error "`var' is not constant over time"
			exit 9
		}
	}
	return local checked "`varlist'"
end
